﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MRP2;

namespace PickyRecorder
{
    public partial class SettingsDialog : Form
    {
        public List<Script.Events> FilteredRecordEvents = new List<Script.Events>();
        public List<Script.Events> FilteredPlayEvents = new List<Script.Events>();
        private const string InfoLabelString = "All of the above checked events will not be {Action}.";

        public SettingsDialog()
        {
            InitializeComponent();
        }

        private void SettingsDialog_Load(object sender, EventArgs e)
        {
            FilteredEventsType.SelectedIndex = 0;
            UpdateFilteredCheckboxes();

            foreach (Control c in groupBox1.Controls)
            {
                if (c.GetType() == typeof(CheckBox))
                {
                    CheckBox checkbox = (CheckBox)c;

                    checkbox.CheckedChanged += new EventHandler(checkbox_CheckedChanged);
                }
            }
        }

        void checkbox_CheckedChanged(object sender, EventArgs e)
        {
            if (FilteredEventsType.SelectedIndex == 0)
                FilteredRecordEvents = FilteredEvents;
            else
                FilteredPlayEvents = FilteredEvents;
        }

        public List<Script.Events> FilteredEvents
        {
            get
            {
                List<Script.Events> filtered = new List<Script.Events>();

                foreach (Control c in groupBox1.Controls)
                {
                    if (c.GetType() == typeof(CheckBox))
                    {
                        CheckBox checkbox = (CheckBox)c;

                        if (checkbox.Checked)
                            filtered.Add(Script.Convert.StringToEvent(checkbox.Text));
                    }
                }

                return filtered;
            }
        }

        private void FilteredEvents_SelectedIndexChanged(object sender, EventArgs e)
        {
            UpdateFilteredCheckboxes();
        }

        private void UpdateFilteredCheckboxes()
        {
            List<Script.Events> filtered;
            if (FilteredEventsType.SelectedIndex == 0)
            {
                InfoLabel.Text = InfoLabelString.Replace("{Action}", "recorded");
                filtered = FilteredRecordEvents;
            }
            else
            {
                InfoLabel.Text = InfoLabelString.Replace("{Action}", "played");
                filtered = FilteredPlayEvents;
            }

            foreach (Control c in groupBox1.Controls)
            {
                if (c.GetType() == typeof(CheckBox))
                {
                    CheckBox checkbox = (CheckBox)c;

                    checkbox.Checked = filtered.Contains(Script.Convert.StringToEvent(checkbox.Text));
                }
            }
        }

        private void Save_Button_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Close();
        }
    }
}
