﻿Imports System.Drawing

Public Class UltraScript : Inherits MRP2Plugin.Plugin
    Public ScreenWidth As Integer = 800
    Public ScreenHeight As Integer = 600

    Public Overrides ReadOnly Property Author As String
        Get
            Return "Nemex"
        End Get
    End Property

    Public Overrides ReadOnly Property Description As String
        Get
            Return "Play your script on any screen resolution!"
        End Get
    End Property

    Public Overrides ReadOnly Property HasSettings As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides ReadOnly Property Name As String
        Get
            Return "UltraScript"
        End Get
    End Property

    Public Overrides Function OnPlayEventProcess(ByVal index As Integer, ByRef ev As MRP2.Script.ScriptItem) As Boolean
        If ev.EventType = MRP2.Script.Events.MousePosition Then
            Dim mousePosition As Point = MRP2.Script.GetMousePosition(ev.EventParameter)

            Dim currentWidth As Integer = My.Computer.Screen.Bounds.Width
            Dim currentHeight As Integer = My.Computer.Screen.Bounds.Height

            mousePosition.X = (mousePosition.X / ScreenWidth) * currentWidth
            mousePosition.Y = (mousePosition.Y / ScreenHeight) * currentHeight
            ev.EventParameter = MRP2.Script.CreateMousePositionParameter(mousePosition.X, mousePosition.Y)
        End If

        Return False
    End Function

    Public Overrides Sub OnPluginClose()

    End Sub

    Public Overrides Function OnPluginCreateToolStripMenuItem() As System.Windows.Forms.ToolStripMenuItem
        Return Nothing
    End Function

    Public Overrides Sub OnPluginLoad()
        ScreenWidth = My.Computer.Screen.Bounds.Width
        ScreenHeight = My.Computer.Screen.Bounds.Height
    End Sub

    Public Overrides Sub OnPluginSettings()
        Dim settingsDiag As New UltraScriptSettings()
        settingsDiag.WidthBox.Value = ScreenWidth
        settingsDiag.HeightBox.Value = ScreenHeight

        If settingsDiag.ShowDialog() = Windows.Forms.DialogResult.OK Then
            ScreenWidth = settingsDiag.WidthBox.Value
            ScreenHeight = settingsDiag.HeightBox.Value
        End If
    End Sub

    Public Overrides Function OnRecordEventProcess(ByRef ev As MRP2.Script.ScriptItem) As Boolean
        Return False
    End Function

    Public Overrides Sub OnRecordStart()

    End Sub

    Public Overrides Sub OnRecordStop()

    End Sub

    Public Overrides Sub OnScriptPlay(ByVal index As Integer)

    End Sub

    Public Overrides Sub OnScriptStop(ByVal index As Integer)

    End Sub

    Public Overrides ReadOnly Property Version As String
        Get
            Return "1.0.0.0"
        End Get
    End Property
End Class
